/*
Copyright 2022 Rancher Labs, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by main. DO NOT EDIT.

package fake

import (
	"context"

	rkecattleiov1 "github.com/rancher/rancher/pkg/apis/rke.cattle.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeRKEBootstraps implements RKEBootstrapInterface
type FakeRKEBootstraps struct {
	Fake *FakeRkeV1
	ns   string
}

var rkebootstrapsResource = schema.GroupVersionResource{Group: "rke.cattle.io", Version: "v1", Resource: "rkebootstraps"}

var rkebootstrapsKind = schema.GroupVersionKind{Group: "rke.cattle.io", Version: "v1", Kind: "RKEBootstrap"}

// Get takes name of the rKEBootstrap, and returns the corresponding rKEBootstrap object, and an error if there is any.
func (c *FakeRKEBootstraps) Get(ctx context.Context, name string, options v1.GetOptions) (result *rkecattleiov1.RKEBootstrap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(rkebootstrapsResource, c.ns, name), &rkecattleiov1.RKEBootstrap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrap), err
}

// List takes label and field selectors, and returns the list of RKEBootstraps that match those selectors.
func (c *FakeRKEBootstraps) List(ctx context.Context, opts v1.ListOptions) (result *rkecattleiov1.RKEBootstrapList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(rkebootstrapsResource, rkebootstrapsKind, c.ns, opts), &rkecattleiov1.RKEBootstrapList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &rkecattleiov1.RKEBootstrapList{ListMeta: obj.(*rkecattleiov1.RKEBootstrapList).ListMeta}
	for _, item := range obj.(*rkecattleiov1.RKEBootstrapList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested rKEBootstraps.
func (c *FakeRKEBootstraps) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(rkebootstrapsResource, c.ns, opts))

}

// Create takes the representation of a rKEBootstrap and creates it.  Returns the server's representation of the rKEBootstrap, and an error, if there is any.
func (c *FakeRKEBootstraps) Create(ctx context.Context, rKEBootstrap *rkecattleiov1.RKEBootstrap, opts v1.CreateOptions) (result *rkecattleiov1.RKEBootstrap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(rkebootstrapsResource, c.ns, rKEBootstrap), &rkecattleiov1.RKEBootstrap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrap), err
}

// Update takes the representation of a rKEBootstrap and updates it. Returns the server's representation of the rKEBootstrap, and an error, if there is any.
func (c *FakeRKEBootstraps) Update(ctx context.Context, rKEBootstrap *rkecattleiov1.RKEBootstrap, opts v1.UpdateOptions) (result *rkecattleiov1.RKEBootstrap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(rkebootstrapsResource, c.ns, rKEBootstrap), &rkecattleiov1.RKEBootstrap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrap), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeRKEBootstraps) UpdateStatus(ctx context.Context, rKEBootstrap *rkecattleiov1.RKEBootstrap, opts v1.UpdateOptions) (*rkecattleiov1.RKEBootstrap, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(rkebootstrapsResource, "status", c.ns, rKEBootstrap), &rkecattleiov1.RKEBootstrap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrap), err
}

// Delete takes name of the rKEBootstrap and deletes it. Returns an error if one occurs.
func (c *FakeRKEBootstraps) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(rkebootstrapsResource, c.ns, name, opts), &rkecattleiov1.RKEBootstrap{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeRKEBootstraps) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(rkebootstrapsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &rkecattleiov1.RKEBootstrapList{})
	return err
}

// Patch applies the patch and returns the patched rKEBootstrap.
func (c *FakeRKEBootstraps) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *rkecattleiov1.RKEBootstrap, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(rkebootstrapsResource, c.ns, name, pt, data, subresources...), &rkecattleiov1.RKEBootstrap{})

	if obj == nil {
		return nil, err
	}
	return obj.(*rkecattleiov1.RKEBootstrap), err
}
